% Make a sparse matrix out of connectivities.
% conns = cell array of connectivity arrays
function A = conn_to_sparse(conns)
n=0; % dimension of the matrix
ns=0; % size of the sparsity pattern arrays
for C=1:length(conns)
    conn=conns{C};
    n=max([max(max(conn)) n]);
    nn=size(conn,2);
    ne=size(conn,1);
    ns=ns+(ne*nn^2);
end
sppatti=zeros(1,ns);
sppattj=zeros(1,ns);
si=1;
for C=1:length(conns)
    conn=conns{C};
    ne=size(conn,1);
    nn=size(conn,2);
    for i=1:ne
        %if (round(i/1000)*1000 == i) disp(['Elem ' num2str(i)]); end
        for j=1:nn
            sppatti(si:si+nn-1)=conn(i,:);
            sppattj(si:si+nn-1)=conn(i,j);
            si=si+nn;
        end
    end
end
A=sparse(sppatti, sppattj, ones(1,length(sppattj)), n, n);
