%
% Initialize the toolbox.
% Usage: [] = famuls_init()
%
function [] = famuls_init()

% Set paths
[homePath,sep] = my_path;
add_subdirs_to_path ([homePath sep '.'], sep);

% Clears the screen and sets format.
format compact;

disp(' ');
disp(' ');
disp('     FAMULS MATLAB TOOLS');
disp(' ');
disp('  FAMULS (C) 2003, Petr Krysl');
disp(' ');
disp('  Please report any problems and/or bugs to: ');
disp('       pkrysl@ucsd.edu');
disp('  ')

disp(['Scripts in ' homePath ':']) ;
dir(homePath)

return;

function add_subdirs_to_path(d, sep)
dl=dir(d);
for i=1:length(dl)
    if (dl(i).isdir)
        if (~ (strcmp(dl(i).name,'CVS') | strcmp(dl(i).name,'cvs')))
            if (~ strcmp(dl(i).name(1),'@'))
                addpath([d sep dl(i).name]);
            end
        end
    end
end
return;

%
% Return path info.
%
function [homepath,fsep] = my_path()
homepath = which('famuls_init');
homepath = homepath(1:length(homepath)-length('famuls_init')-3);
fsep = filesep;
return;
