% Run as 
%   renumber_famuls_prob(prob, ggs)
% where
%   prob = character array: name of the problem (usually the name of the .fpar file, 
%          without the suffix)
%   ggs  = cell array of gcell group names.
% Example:
%          renumber_famuls_prob('Cable', {'gg1' 'gg2' 'gg3'})
%
function renumber_famuls_prob(prob, ggs)
conns=cell(length(ggs));
for i=1:length(ggs)
    conn=load([prob '-' ggs{i} '.conn']);
    conns{i}=conn;
end
fen=load([prob '.fen']);

[pfen,pconns]=renum(fen, conns);

write_famuls_fen(['orig-' prob],fen);
for i=1:length(ggs)
    write_famuls_conn(['orig-' prob], ggs{i}, conns{i});
end

write_famuls_fen([prob],pfen)
for i=1:length(ggs)
    write_famuls_conn([prob], ggs{i}, pconns{i});
end

